#include <stdio.h>
#include "gmp-impl.h"

#define LSZ ((int) (2 * sizeof(mp_limb_t)))

struct gcd_22 {mp_limb_t g0; mp_limb_t g1;};

struct gcd_22 mpn_gcd_22 (mp_limb_t, mp_limb_t, mp_limb_t, mp_limb_t);

int
main ()
{
  mp_limb_t up[2];
  mp_limb_t vp[2];
  struct gcd_22 g;
  mp_limb_t refp[2];
  mp_limb_t resp[2];

#define INTERVAL 0x10000
  for (unsigned long i = 0;; i++)
    {
      if (i % INTERVAL == INTERVAL - 1)
	{
//	  printf ("\r%c", "/-\\|"[i / INTERVAL % 4]);
	  printf ("\r%lu", i);
	  fflush (stdout);
	}
      switch (i)
	{
#if 1
	case 0:
	  up[1] = 0; up[0] = 257;
	  vp[1] = GMP_NUMB_MAX; vp[0] = GMP_NUMB_MAX;
	  break;
	case 1:
	 up[1] = GMP_NUMB_MAX; up[0] = GMP_NUMB_MAX;
	 vp[1] = 0; vp[0] = 257;
	 break;
#endif
	case 2:
	  up[1] = 1; up[0] = 1;
	  vp[1] = GMP_NUMB_MAX; vp[0] = GMP_NUMB_MAX;
	  break;
	case 3:
	 up[1] = GMP_NUMB_MAX; up[0] = GMP_NUMB_MAX;
	 vp[1] = 1; vp[0] = 1;
	 break;
	case 4:
	  up[1] = 1; up[0] = 3;
	  vp[1] = GMP_NUMB_MAX; vp[0] = GMP_NUMB_MAX;
	  break;
	case 6:
	  up[1] = 1; up[0] = 5;
	  vp[1] = GMP_NUMB_MAX; vp[0] = GMP_NUMB_MAX;
	  break;
	default:
	  mpn_random2 (up, 2);
	  up[0] |= 1;
	  mpn_random2 (vp, 2);
	  vp[0] |= 1;
	  break;
	}
//      vp[0] = up[0];
//      vp[1] = up[1];

//      printf ("U = %lX%0*lX\n", vp[1], LSZ, vp[0]);
//      printf ("V = %lX%0*lX\n", up[1], LSZ, up[0]);

#if TIMING
      unsigned p0[2], p1[2];
      const unsigned REPS = 1000000;
      speed_cyclecounter(p0);
      for (int j = 0; j < REPS; j++)
	g = mpn_gcd_22 (up[1], up[0], vp[1], vp[0]);
      speed_cyclecounter(p1);
      printf ("%f\n", (double) (p1[0] - p0[0]) / REPS / 64);
#else
      g = mpn_gcd_22 (up[1], up[0], vp[1], vp[0]);

//      printf ("22: %lX%0*lX\n", gp[1], LSZ, gp[0]);
//      printf ("22: %lX%0*lX\n", gp[3], LSZ, gp[2]);

      int s = mpn_gcd (refp, up, 2, vp, 2);
      if (s == 2)
	{
	  if (g.g1 != refp[1] || g.g0 != refp[0])
	    {
	      printf ("U = %lX%0*lX\n", vp[1], LSZ, vp[0]);
	      printf ("V = %lX%0*lX\n", up[1], LSZ, up[0]);
	      printf ("RES %lX%0*lX\n", g.g1, LSZ, g.g0);
	      printf ("REF %lX%0*lX\n", refp[1], LSZ, refp[0]);
	      printf ("%lu ============================================\n", i);
	    }
	}
      else
	{
	  if (g.g0 != refp[0])
	    {
	      printf ("U = %lX%0*lX\n", vp[1], LSZ, vp[0]);
	      printf ("V = %lX%0*lX\n", up[1], LSZ, up[0]);
	      printf ("RES %lX\n", g.g0);
	      printf ("REF %lX\n", refp[0]);
	      printf ("%lu ============================================\n", i);
	    }
	}
#endif
    }
  return 0;
}
